/* -------------------------------------------------------

This shader implements a directional light per pixel using  the 
diffuse, specular, and ambient terms acoording to "Mathematics of Lighthing" 
as found in the book "OpenGL Programming Guide" (aka the Red Book)

--------------------------------------------------------- */

uniform sampler2D tex0;
varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;


void main()
{
	vec3 n,halfV,viewV,ldir;
	float NdotL,NdotHV;
	vec4 t;
	vec4 color = ambient;
	

	/* a fragment shader can't write a verying variable, hence we need
	a new variable to store the normalized interpolated normal */
	n = normalize(normal);
	
	/* compute the dot product between normal and ldir */
	NdotL = max(dot(n,lightDir),0.0);

	if (NdotL > 0.0) {
		halfV = normalize(halfVector);
		NdotHV = max(dot(n,halfV), 0.0);
		
		color += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
		color += diffuse * NdotL;
	}

	/*vec4 texture = (texture2D (tex0, gl_TexCoord[0].st));
	vec3 col = mix (color.rgb, gl_TextureEnvColor[0].rgb, texture.rgb);
	color = vec4 (col, color.a * texture.a);*/
	
	gl_FragColor = color * (texture2D (tex0, gl_TexCoord[0].st) * 2.5);
	/*gl_FragColor = color;*/
	
}
